;FUSES PROGRAMMED (bits = 0):
;JTAGEN  SPIEN  CKOPT  EESAVE  BOOTSZ1  BOOTSZ0 BODLEVEL  BODEN  SUT0  CKSEL3  CKSEL2  CKSEL1

;LOCKS PROGRAMMED (bits = 0): None

; :
;  b  - 
;    - 
;  e  -  EEPROM
;  eb -  EEPROM
;  k  -  (  )
;  m  -  SRAM
;  mb -  SRAM
;  r  - 
;  re - ,    EEPROM
;  s  - 
;  sb - 
;  p  -  /
;        .
; 1   ,  2 - .

.include "m16def.inc"

  ; :
.equ	BuildForSimulator = 0

  ; :
.def	rOutChannels	  = R3	;  .
.def	reNoiseImmunity	  = R4	;  eeprom,  -    INT2     .
.def	reDelayBeforeOn	  = R5	;  eeprom,      ()        .
.def	reLastBright1_1   = R6	;  eeprom,     1   .
.def    reLastBright1_2   = R7	;  eeprom,     1   .
.def	reLastBright2_1   = R8	;  eeprom,     2   .
.def	reLastBright2_2   = R9	;  eeprom,     2   .
.def	Tmp		  = R15	;   .
.def	Temp		  = R16 ;   .
.def	rButton1PushedTime= R17 ;    1.
.def	rButton2PushedTime= R18 ;    2.
.def	rBrightness1	  = R19	;    1.
.def	rBrightness2	  = R20	;    2.
.def	rCh1OffTime	  = R21	;,     1.
.def	rCh2OffTime	  = R22	;,     2.
.def	reBit		  = R23	;   eeprom.
.def	rBit		  = R24	;  :
  .equ	  bSoftTurn1	    = 0	;  ,   /  1 (  1).
  .equ	  bSoftTurn2        = 1	;  ,   /  2 (  1).
  .equ	  bIsChannel1On     = 2	;      1 ( 1,  ).
  .equ	  bIsChannel2On     = 3	;      2 ( 1,  ).
  .equ	  bBritnessVector1  = 4	;     1 ( 1      ,  0 - ).
  .equ	  bBritnessVector2  = 5	;     2 ( 1      ,  0 - ).
  .equ    bTimer2Mode 	    = 6	;       ( 1 -   ,  0 -   ).
.def	rBit2		  = R25	;  :
  .equ    bChannel1Mode	    = 0	;       (    -  1,   0;    -  2,   1).
  .equ    bChannel2Mode	    = 1	;       (    -  1,   0;    -  2,   1).
  
  ; :
.equ	pMainOut = PORTA	;  .
  .equ	  bChannel1 = 0		; 1 ( 0).
  .equ	  bChannel2 = 1		; 2 ( 1).
.equ	pKeyboardIn = PIND	;  .
  .equ	  sbFirstChannel = 0	;    1.
  .equ    sbSecondChannel= 1	;    2.


  ; :	   eeprom.

  ;,   :
.equ	cTimer2Freq     = 38	;    ( cTimer2Freq=38, Timer2Prescale=8, f=1MHz    38).

  ; RAM:
;.dseg
;mTemp:	.byte	1	;  .

  ; EEPROM:
.eseg
eBrightChangeDelay1:  .db  70	;              1 (  ,   ).     eTurnDuration1.
eBrightChangeDelay2:  .db  70	;              2 (  ,   ).     eTurnDuration2.
eBrightChangeSpeed1:  .db  3	;    1 (   0  10).
eBrightChangeSpeed2:  .db  2	;    2 (   0  10).
eLastBright1_1:       .db  128	;   1        (   ).
eLastBright1_2:       .db  255	;   1        (   ).
eLastBright2_1:       .db  128	;   2        (   ).
eLastBright2_2:       .db  255	;   2        (   ).
eTurnDuration1:	      .db  50	;         1    \   .     cBrightChangeDelay1.
eTurnDuration2:	      .db  50	;         2    \   .     cBrightChangeDelay2.
eNoiseImmunity:	      .db  5	;-    INT2     .
eDelayBeforeOn:	      .db  50;38	;   ()         (   30  40).
eBit:		      .db  \
  (0<<ebPowerState1)    + \
  (0<<ebPowerState2)    + \
  (1<<ebBrightDirMode1) + \
  (0<<ebBrightDirMode2) + \
  (0<<ebTurnPrevState1) + \
  (1<<ebTurnPrevState2);+ \
;   eBit:
  .equ	ebPowerState1 	  = 7	;   1 ( 1   )
  .equ	ebPowerState2 	  = 6	;   2 ( 1   )
  .equ	ebBrightDirMode1  = 5	;    1 -  1   ,  .   0      .
  .equ	ebBrightDirMode2  = 4	;    2 -  1   ,  .   0      .
  .equ	ebTurnPrevState1  = 3	;     1       ( 1,  )
  .equ	ebTurnPrevState2  = 2	;     2       ( 1,  )
;eTemp:	.db 0


.cseg
.org	$000	 rjmp RESET	;Reset Handler.
.org	OC2addr  rjmp TIM2_COMP	;Timer2 Compare Handler.
.org	INT2addr rjmp EXT_INT2	;IRQ2 Handler.


.org	 $030
.include "Interrupts.inc"
.include "Procedures.inc"
.include "Reset.inc"
.include "Startup.inc"

;*****************************************************************************

Main0:	
.if	BuildForSimulator == 0 ;        wdr  Atmega16 (  4.11 build 406 SP2  ).
wdr			
.endif
rjmp	Main0

;*****************************************************************************

NormalizedBrightness:
;    38 (t=38*38=1444)  240 (t=240*38=9120).
.db \
38   ,\
38   ,\
38   ,\
38   ,\
38   ,\
38   ,\
38   ,\
38   ,\
38   ,\
38   ,\
39   ,\
39   ,\
40   ,\
40   ,\
41   ,\
41   ,\
42   ,\
42   ,\
43   ,\
43   ,\
44   ,\
44   ,\
45   ,\
45   ,\
46   ,\
46   ,\
47   ,\
47   ,\
48   ,\
48   ,\
49   ,\
49   ,\
50   ,\
50   ,\
51   ,\
51   ,\
52   ,\
52   ,\
53   ,\
53   ,\
54   ,\
54   ,\
55   ,\
55   ,\
56   ,\
56   ,\
57   ,\
57   ,\
58   ,\
58   ,\
59   ,\
59   ,\
60   ,\
60   ,\
61   ,\
61   ,\
62   ,\
62   ,\
63   ,\
63   ,\
64   ,\
64   ,\
65   ,\
65   ,\
66   ,\
66   ,\
67   ,\
67   ,\
68   ,\
68   ,\
69   ,\
69   ,\
70   ,\
70   ,\
71   ,\
71   ,\
72   ,\
72   ,\
73   ,\
73   ,\
74   ,\
74   ,\
75   ,\
75   ,\
76   ,\
76   ,\
77   ,\
77   ,\
78   ,\
78   ,\
79   ,\
79   ,\
80   ,\
80   ,\
81   ,\
81   ,\
82   ,\
82   ,\
83   ,\
83   ,\
84   ,\
84   ,\
85   ,\
85   ,\
86   ,\
86   ,\
87   ,\
87   ,\
88   ,\
88   ,\
89   ,\
89   ,\
90   ,\
90   ,\
91   ,\
91   ,\
92   ,\
92   ,\
93   ,\
93   ,\
94   ,\
94   ,\
95   ,\
95   ,\
96   ,\
96   ,\
97   ,\
97   ,\
98   ,\
98   ,\
99   ,\
99   ,\
100   ,\
100   ,\
101   ,\
102   ,\
102   ,\
103   ,\
104   ,\
104   ,\
105   ,\
106   ,\
106   ,\
107   ,\
108   ,\
108   ,\
109   ,\
110   ,\
110   ,\
111   ,\
112   ,\
112   ,\
113   ,\
114   ,\
114   ,\
115   ,\
116   ,\
117   ,\
118   ,\
119   ,\
120   ,\
121   ,\
122   ,\
123   ,\
124   ,\
125   ,\
126   ,\
127   ,\
128   ,\
129   ,\
130   ,\
131   ,\
132   ,\
133   ,\
134   ,\
135   ,\
136   ,\
137   ,\
138   ,\
139   ,\
140   ,\
141   ,\
142   ,\
143   ,\
144   ,\
145   ,\
146   ,\
147   ,\
148   ,\
149   ,\
150   ,\
151   ,\
152   ,\
153   ,\
154   ,\
155   ,\
156   ,\
157   ,\
158   ,\
159   ,\
160   ,\
161   ,\
162   ,\
163   ,\
164   ,\
165   ,\
166   ,\
167   ,\
168   ,\
169   ,\
170   ,\
171   ,\
172   ,\
173   ,\
174   ,\
175   ,\
176   ,\
178   ,\
180   ,\
182   ,\
184   ,\
186   ,\
188   ,\
190   ,\
192   ,\
194   ,\
196   ,\
198   ,\
200   ,\
203   ,\
206   ,\
209   ,\
212   ,\
215   ,\
218   ,\
221   ,\
224   ,\
228   ,\
232   ,\
236   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237   ,\
237
